#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use DBI;
use CGI;
use CGI::Carp qw(fatalsToBrowser);
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

$default_permissions = 0777;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));
$gsettings = new_gsettings acs;

$pages_prev = "10";
$pages_next = "10";


##################################################################################

if (($q->param('fct') eq "") and ($q->param('lv') eq "")) 
	{
	acs::extend_login;
	}
	else
	{
	print "Content-type: text/html\n\n";
	}

if ($q->param('fct') eq "") {&manage_dirs;}
if ($q->param('fct') eq "addir") {&addir;}
if ($q->param('fct') eq "add_dir_final") {&add_dir_final;}
if ($q->param('fct') eq "edit_dir") {&edit_dir;}
if ($q->param('fct') eq "edit_dir_final") {&edit_dir_final;}
if ($q->param('fct') eq "delete_dir") {&delete_dir;}
if ($q->param('fct') eq "delete_dir_final") {&delete_dir_final;}
if ($q->param('fct') eq "addir_m") {&addir_m;}
if ($q->param('fct') eq "add_mdirs_final") {&add_mdirs_final;}
if ($q->param('fct') eq "delete_proc") {&delete_proc;}



##################################################################################


sub add_mdirs_final
{

$lv = $q->param('lv');
$cid = $q->param('cid');
$ct = $q->param('ct');
$rid = $q->param('rid');
$mdirs = $q->param('mdirs');
$mdirs =~ s/_/ /g;

########### CHECK MAX 20

#$dir_str_cnt = 0;
#@alldirs1 = split (/\n/, $mdirs);
#foreach $item (@alldirs1)
#	{
#	$item =~ s/\\//g;
#	$mdirs2 = $mdirs2 . $item . "\n";
#	$dir_str_cnt++;
#	}
#$mdirs = $mdirs2;
#
#if ($dir_str_cnt > 20) { acs::problem_popup("You can only add 20 directories at a time."); exit;}

###########




if ($mdirs eq ""){acs::problem_popup("You have to supply at least 1 directory name.");}


#### CHECK FOR DUPLICATES

#### RETRIEVE EXISTING DIRS
if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

if ($lv == 0)
	{
	$sth = $dbh->prepare("SELECT * FROM dirs WHERE (level = '1') ORDER BY shortname ASC");
	}
	else
	{
	$lv++;
	@adir = split (/-/, $ct);
	
	$querystr = "";

	for ($ms = 0; $ms < 16; $ms++) 
		{
		if ($adir[$ms] ne "") {$adir[$ms] = acs::decode_dir($adir[$ms]);}

		$acnt = $ms + 1;
		if ($acnt != $lv)
			{
			if ($adir[$ms] ne "")
				{
				$adir[$ms] =~ s/'/\\'/g;
				#$adir[$ms] =~ s/\\//g;
				}
			$querystr = $querystr . " (l" . "$acnt = '$adir[$ms]') and";
			}
		$acnt++;
		}
	$querystr = substr($querystr, 0, length($querystr) - 3);
	
			#### CHECK IF SOMETHING DID'NT CHANGE
			$cclv = $lv - 1;
			$wsql = "SELECT * FROM dirs WHERE (level = '$cclv') and $querystr";
			$sth = $dbh->prepare($wsql);
			$sth->execute;
			$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
			$rows = $sth->rows();
			
			#print "SELECT * FROM dirs WHERE (level = '$cclv') and $querystr";
			if ($rows < 1)
				{
				acs::problem_popup("The category/directory to which you are trying to add categories/directories to, changed - unable to save the changes. Close this window, refresh it's parent and try again.");
				$sth->finish;
				$dbh->disconnect;
				}
			######################################

	$sth = $dbh->prepare("SELECT * FROM dirs WHERE (level = '$lv') and $querystr ORDER BY shortname ASC");
	}

if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
$rows = $sth->rows();


####

$smc = 0;
while ( @row = $sth->fetchrow() )
	{
	$existing_dirs[$smc] = $row[28];
	$smc++;
	}


##### PREPARE NEW DIR NAMES
	
$blcn = 0;
@alldirs1 = split (/\n/, $mdirs);
$ncnt = 0;
foreach $item (@alldirs1)
	{
	$item =~ s/\n//g; 
	$mcrit = chr(10); $item =~ s/$mcrit//g;
	$mcrit = chr(13); $item =~ s/$mcrit//g;
	$item = acs::remove_leading_spacing($item);

	foreach $added_dir (@alldirs)
		{
		if (lc($item) eq lc($added_dir)){$item = "";}
		}

	if ($item ne "")
		{
		$alldirs[$ncnt] = $item;
		$ncnt++;
		}
	}

######################


foreach $edir (@existing_dirs)
	{

	foreach $ndir (@alldirs)
		{
		
		#####
		if (lc($ndir) eq lc($edir))
			{
			$duplicate_found = "true";
			$dupdirs[$blcn] = "$ndir";
			$blcn++;
			}
		#####
			
		}

	}


if ($duplicate_found eq "true")
	{
	&duplicate_found_error;	exit;
	}


#### ADD DIRECTORIES

 ### BUILD QUERY
 if ($lv eq "") { $lv = 1; } 
 $sql = "INSERT INTO dirs SET level = '$lv', linknrs = '0',";
 
	$iic = 1;
	@ditems = split (/-/, $ct);
	foreach $item (@ditems)
		{
		
		$item = acs::decode_dir($item);
		$item =~ s/'/\\'/g;
		#$item =~ s/\\//g;
		$cname = "l" . $iic;
		
		$sql = $sql . " $cname = '$item',";
		$iic++;
		}

		for ($ms = ($iic + 1); $ms < 17; $ms++) 
			{
			$cname = "l" . $ms;
			$sql = $sql . "$cname = '', ";
			}

$last_cname = "l" . $iic;

foreach $item (@alldirs)
{
$item =~ s/'/\\'/g;

$querystr = "$sql $last_cname = '$item', shortname = '$item'";

#print "==> $querystr <br><br><br>";

$sth = $dbh->prepare("$querystr");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $querystr";}


$sth = $dbh->prepare("SELECT cid FROM dirs WHERE cid = LAST_INSERT_ID()");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
while ( @row = $sth->fetchrow() ) {$last_ids = $last_ids . $row[0] . ":\n"; }  

}

$sth->finish;
$dbh->disconnect;


if ($cid eq "")
	{
	open (CFILE, ">> $data_dir/changed_cats.dat");
		print CFILE $last_ids;
	close (CFILE);
	}
	else
	{
	open (CFILE, ">> $data_dir/changed_cats.dat");
		print CFILE "$cid" . ":F\n";
		print CFILE $last_ids;
	close (CFILE);
	}




############
if ($lv != 0){ $lv = $lv - 1; }


$hbox = acs::get_heading_box("$web_url/add.gif", "Categories/Directories Created", qq[You may <a href="javascript:onClick=window.close()"><b>close</b></a> this window.]);


print <<END_OF_ADDED;

<html>

<head>
<title>Add New Directories</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>

<body onUnload="opener.location.reload(true);">

$hbox

</body>
</html>

END_OF_ADDED

}





#######

sub duplicate_found_error
{

foreach $item (@dupdirs)
	{
	$dupdirs = $dupdirs . "<li>$item</li>";
	}

foreach $edir (@alldirs)
	{
	$toad_dirs = $toad_dirs . $edir . "\n";
	}

if ($ct ne "")
	{
	$location = acs::decode_complete_dir($ct);
	}
	else
	{
	$location = "Root ";
	}

if ($lv != 0) { $lv = $lv - 1; }


$hbox = acs::get_heading_box("$web_url/add.gif", "Add Multiple Categories/Directories", qq[<font color="#FF0000"><b>

<p>Problem:</b></font> No categories/directories added because the following
categories/directories already exists:</p>

<blockquote>
  <p><strong>$dupdirs</strong></p>
</blockquote>

<p>Please remove the duplicates from the box below and try again.</p>
]);



print <<END_OF_DIPLC;

<html>
<head>
<title>Add New Directories</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>

$hbox

<form method="POST" action="$admin_url/admin2.cgi">
  <table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#DDDDDD">
    <tr>
      <td height="30" valign="top" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Enter Category/Directory Names on an empty line:</strong></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><textarea rows="31" name="mdirs" cols="60"
      style="width:100%">$toad_dirs</textarea></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">
        <input type="submit"
      value="Add Categories/Directories" name="B2">
        <input type="hidden" name="ct" value="$ct">
        <input type="hidden" name="fct" value="add_mdirs_final">
        <input type="hidden" name="lv" value="$lv">
        <input type="hidden"
  name="cid" value="$cid">
</font></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
  </form>



</body>
</html>

END_OF_DIPLC

}






sub addir_m
{

$lv = $q->param('lv');
$cid = $q->param('cid');
$ct = $q->param('ct');
$rid = $q->param('rid');

if ($ct ne "")
	{
	$location = acs::decode_complete_dir($ct);
	}
	else
	{
	$location = "Root ";
	}


$hbox = acs::get_heading_box("$web_url/add.gif", "Add Multiple Categories/Directories", qq[Add New Categories/Directories To: <b>$location</b>]);



print <<END_OF_MDIRS

<html>

<head>
<title>Add a New Directories</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>

<body>

$hbox

<form method="POST" action="$admin_url/admin2.cgi">
  <table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#DDDDDD">
    <tr>
      <td height="30" valign="top" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Enter One Category/Directory on an empty line: (One category 'per line')</strong></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><textarea rows="31" name="mdirs" cols="60"
      style="width:100%"></textarea></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="1">
        <input type="submit"
      value="Add Categories/Directories" name="B2">
        <input type="hidden" name="ct" value="$ct">
        <input type="hidden" name="fct" value="add_mdirs_final">
        <input type="hidden" name="lv" value="$lv">
        <input type="hidden"
  name="cid" value="$cid">
</font></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
  </form>



</body>
</html>

END_OF_MDIRS

}





sub delete_dir_final
{

$lv = $q->param('lv');
$cid = $q->param('cid');
$ct = $q->param('ct');
$rid = $q->param('rid');
$crossl = $q->param('crossl');
$prev_cid = $q->param('prev_cid');


##### GET FIRST DIRECTORY IN DIRECTORY SEQUENCE

@adirs = split (/-/, $ct);

$lcntr = 1;
foreach $item (@adirs)
	{
	$item = acs::decode_dir($item);
	$item =~ s/'/\\'/g;

	$fname = "l" . $lcntr;
	$qstring = $qstring  . " ($fname = '$item') and";
	$lcntr++;
	}
	$qstring = substr($qstring, 0, length($qstring) - 3);


##########

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


###### GET DIR IDS WHERE LINKS SHOULD BE DELETED

$lvname = "l" . $lv;
$wsql = "SELECT cid FROM dirs WHERE $qstring ORDER BY cid DESC";

$sth = $dbh->prepare($wsql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $wsql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}

$rows = $sth->rows();
if ($rows < 1) 
		{
		$sth->finish;
		$dbh->disconnect;
		acs::problem_popup("The category/directory you are trying to delete does not exist anymore. Close this window, refresh it's parent and try again.");
		}

$cidline_count = 5; $ncount = 1;
while ( @row = $sth->fetchrow() )
	{
	$link_del_sql = $link_del_sql . " (cid = '$row[0]') or";
	

		if ($ncount < $cidline_count)
		{
		$cids_to_del = $cids_to_del . $row[0] . ":";
		}
		else
		{
		$cids_to_del = $cids_to_del . $row[0] . "\n";
		$ncount = 0;
		}
	
	$ncount++;
	
	$normall = $normall . $row[0] . " - ";
	}

$link_del_sql = substr($link_del_sql, 0, length($link_del_sql) - 2);


###### CHECK IF NEW SUBMISSION PRESENT

if (($q->param('newsub_del') ne "newsub_del") and ($crossl ne "true"))
{

	$newsubm_sql = "SELECT title, description, url FROM links WHERE ($link_del_sql) AND (newsubm = 'Y')";
	$sth = $dbh->prepare($newsubm_sql);
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $wsql"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
	$rows = $sth->rows();

	if ($rows > 0)
		{
		$newsubm = "";
			while ( @row = $sth->fetchrow() )
			{
			$newsubm = $newsubm . "<a href=\"$row[2]\" target=\"_blank\"><b>$row[0]</a></b><BR>";
			$newsubm = $newsubm . "$row[1]<BR>";
			$newsubm = $newsubm . "<b>$row[2]</b><BR><br>";
			}


$hbox = acs::get_heading_box("$web_url/ic_exclamation.gif", "Delete Directory/Category", qq[
<form method="POST" action="$admin_url/admin2.cgi">
  <input type="hidden" name="cid" value="$cid"><input type="hidden" name="ct" value="$ct"><input
  type="hidden" name="fct" value="delete_dir_final"><input type="hidden" name="lv"
  value="$lv"><input type="hidden" name="rid" value="$rid"><input type="hidden" name="rid"
  value="$rid"><input type="hidden" name="crossl" value="$crossl"><input type="hidden"
  name="newsub_del" value="newsub_del"><p>The following new submissions has been found in a
  directory that will be deleted. These new submissions will also be deleted:</p>
  <blockquote>
    <p>$newsubm</p>
  </blockquote>
  <p>You can move or approve the above new submissions by going to the new submissions
  approval area.</p>
  <p><strong>Are you sure? <input type="submit" value="    Yes    " name="B1"> </strong>
  <input type="submit" value="    No    " name="B2" onclick="window.close(); return false;"></p>
</form>
]);



print <<END_OF_CONFIRM;

<html>

<head>
<title>Delete Directory</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>

<body>

$hbox

</body>
</html>

END_OF_CONFIRM
	exit;		
	}
}


### FIND OUT HOW MANY LINKS WILL BE DELETED
$wsql = "SELECT COUNT(*) FROM links WHERE $link_del_sql";
$sth = $dbh->prepare($wsql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $wsql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
	while ( @row = $sth->fetchrow() )
		{
		$total_links_to_delete = $row[0];
		}


#### CREATE TEMP DIR WHERE WE WILL STORE TEMP DATA
$temp_dir = "$data_dir/tmp";
if ((-e $temp_dir) < 1) {
mkdir ($temp_dir, $default_permissions);
chmod($default_permissions,"$temp_dir","$temp_dir"); }

$tmpfname = "$data_dir/tmp/$cid" . ".del";
open (TMPD, "> $tmpfname");
	print TMPD $cids_to_del;
close (TMPD);



$sth->finish;
$dbh->disconnect;



###### UPDATE LINK NUMBERS

if ($crossl ne "true")
{

@rits = split (/-/, $rid);
$nrdirs = @rits; $nrdirs = $nrdirs - 1;

$rits[$nrdirs] = "";

foreach $item (@rits)
	{
	if ($item ne "")
		{
		$new_rid = $new_rid . $item . "-";
		}
	}
	
chop($new_rid);

if ($new_rid ne "")
	{
	acs::update_numbers("-", $total_links_to_delete, $new_rid);
	}
}


#### RECORD CHANGES SO THAT WE CAN GENERATE ONLY CHANGES WHEN GENERATING HTML FILES

if ($prev_cid ne "")
	{
	open (CFILE, ">> $data_dir/changed_cats.dat");
		print CFILE "$prev_cid" . ":LEVEL_WHOLE\n";
	close (CFILE);
	}



### SET UP DELETION

$hbox = acs::get_heading_box("$web_url/ic_erase.gif", "Deleting Categories/Directories & Listings. Please Wait...", qq[<img src="$web_url/working.gif" width="270" height="36">]);

print qq[<html>
<head>
<title>Delete</title>
<meta HTTP-EQUIV="REFRESH"
CONTENT="0;URL=$admin_url/admin2.cgi?fct=delete_proc&amp;cid=$cid&amp;totlinks=$total_links_to_delete">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>

$hbox

</body>
</html>

];


}






sub delete_proc
{

$cid = $q->param('cid');
$cpos = $q->param('cpos'); if ($cpos eq "") { $cpos = 0; }
$total = $q->param('total');
$newpos = $cpos + 1;

$totlinks = $q->param('totlinks');

$linecounter = 0;

$tmpfname = "$data_dir/tmp/$cid" . ".del";	
open (STP, "$tmpfname");
 while (defined($line=<STP>))
  {

	if ($linecounter == $cpos)
		{
		$currentdels = $line;
		$currentposition = $linecounter;
		}

	$linecounter++;
  }
close (STP);


if ($cpos == 0) { $total = $linecounter; }



#### IF FINISHED

if ($currentdels eq "") 
{

$hbox = acs::get_heading_box("$web_url/ic_erase.gif", "Category/Directory Deleted.", qq[You may <strong><a href="javascript:onClick=window.close()">close</a></strong> this window.]);


print qq[

<html>

<head>
<title>Delete Directory</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>

<body onUnload="opener.location.reload(true);">

$hbox

</body>
</html>
];

unlink ("$tmpfname");


exit;
}




@sitems = split (/:/,$currentdels);

	foreach $item (@sitems)
		{
		$sqlq = $sqlq . "(cid = '$item') OR ";
		}
		$sqlq = substr($sqlq, 0, length($sqlq) - 3);


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

	$wsql = "DELETE FROM links WHERE $sqlq";
	$sth = $dbh->prepare($wsql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
	$rows = $sth->rows();

	$wsql2 = "DELETE FROM dirs WHERE $sqlq";
	$sth = $dbh->prepare($wsql2);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
	$rows = $sth->rows();

$sth->finish;
$dbh->disconnect;


$perc = $currentposition / $total * 100;
$perc = sprintf("%5.2f",$perc); 
$perc = $perc . "%";


#$totlinks


$hbox = acs::get_heading_box("$web_url/ic_erase.gif", "Deleting Categories/Directories & Links. Please Wait...", qq[Deleting $totlinks Links. Deleting $currentposition of $total Categories/Directories]);


print qq[

<html>

<head>
<title>Delete</title>
<meta HTTP-EQUIV="REFRESH"
CONTENT="1;URL=$admin_url/admin2.cgi?fct=delete_proc&amp;cid=$cid&amp;cpos=$newpos&amp;total=$total&totlinks=$totlinks">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>

<body>

$hbox

<table border="0" cellpadding="4" cellspacing="0" width="100%"
style="border: 1px solid rgb(192,192,192)">
  <tr>
    <td width="19%" style="border-right: 1px solid rgb(192,192,192)"><img
    src="$web_url/working.gif" width="270" height="36"></td>
    <td width="19%" style="border-right: 1px solid rgb(192,192,192)"><p align="center"><font
    face="Verdana" size="1">Complete: <strong>$perc</strong></font></td>
    <td width="81%" align="left"><table border="0" cellpadding="6" cellspacing="0"
    width="$perc" height="30">
      <tr>
        <td width="100%" background="$web_url/bar.gif"></td>
      </tr>
    </table>
    </td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>

</body>
</html>

];


}






sub delete_dir
{

$lv = $q->param('lv');
$cid = $q->param('cid');
$ct = $q->param('ct');
$rid = $q->param('rid'); 
$crossl = $q->param('crossl');
$prev_cid = $q->param('prev_cid');

$location = "Root ";
@dits = split (/-/, $ct);
$dc=0;
foreach $item (@dits)
	{
	$dits[$dc] = acs::decode_dir($item);
	$dc++;
	$location = $location . " > $item";
	}

if ($crossl eq "true")
	{
	$dltext = "This category/directory is a crosslink. This action will only remove the crosslink.<br>";
	}
	else
	{
	$dltext = "All sub categories/directories with their links will be lost.";
	}


$hbox = acs::get_heading_box("$web_url/ic_exclamation.gif", "Delete Directory/Category", qq[<form method="POST" action="$admin_url/admin2.cgi">
  <input type="hidden" name="cid" value="$cid"><input type="hidden" name="ct" value="$ct"><input
  type="hidden" name="fct" value="delete_dir_final"><input type="hidden" name="lv"
  value="$lv"><input type="hidden" name="rid" value="$rid"><input type="hidden" name="rid"
  value="$rid"><input type="hidden" name="crossl" value="$crossl">
  <input type="hidden" name="prev_cid" value="$prev_cid"><p>$dltext <strong>Are you sure? 
  <input type="submit" value="    Yes    " name="B1">
  <input type="submit" value="    No    " name="B2" onclick="window.close(); return false;"></p>
</form>]);


print <<END_OF_EDIT;

<html>
<head>
<title>Delete Directory</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox

</body>
</html>
  
END_OF_EDIT

}






sub edit_dir_final
{

###### ERROR CHECKING
if ($q->param('directory_name') eq "") {acs::problem_popup("You have to specify a name for the directory/category.");}
######################

$ct =  $q->param('ct');
$lv =  $q->param('lv');
$cid = $q->param('cid');

$cat_title = $q->param('cat_title');
$cat_title =~ s/'/\\'/g;

$metatag = $q->param('metatag');
$metatag =~ s/'/\\'/g;

$mkeyw = $q->param('mkeyw');
$mkeyw =~ s/'/\\'/g;

$directory_name = $q->param('directory_name');
$directory_name =~ s/_/ /g;
$directory_name = acs::remove_leading_spacing($directory_name);
$directory_name =~ s/'/\\'/g;

@adirs = split (/-/, $ct);
$adnr = @adirs; $adnr = $adnr - 1;

$lcntr = 1;
foreach $item (@adirs)
	{
	$cnt = $lcntr - 1;
	$adirs[$cnt] =~ s/'/\\'/g;
	
	$item2 = acs::decode_dir($item);
	$item2 =~ s/'/\\'/g;
	
	$fname = "l" . $lcntr;
	$qstring = $qstring  . " ($fname = '$item2') and";
	
	if ($lcntr != ($adnr + 1)){$qstring2 = $qstring2  . " ($fname = '$item2') and";}
	
	$lcntr++;
	}
	$qstring = substr($qstring, 0, length($qstring) - 3);
	$qstring2 = substr($qstring2, 0, length($qstring2) - 3);

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


###### CHECK DUPLICATES 

$psn = acs::decode_dir($adirs[$adnr]);
$psn =~ s/'/\\'/g;


if ($psn ne $directory_name)
	{
	$qstring2 = $qstring2 . " and (l" . ($lcntr -1) . " = '$directory_name')";
	
	if ($lv == 1) {$qstring2 =~ s/AND/ /gi;}
	
	$wsql = "SELECT shortname FROM dirs where $qstring2";
	
	
	$sth = $dbh->prepare($wsql);
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From :$wsql"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
	
	$rows = $sth->rows();
	
	if ($rows > 0){acs::problem_popup("The directory name you specified would create a duplicate.");}
	}



### IF THERE IS RELATED CATEGORIES ASSOCIATED WITH THIS CATEGORY - CHECK IF THEY EXIST

$related_categories = $q->param('related_categories');
$related_categories =~ s/ //g;
if ($related_categories ne "")
{

$related_dirs_sql = "SELECT cid FROM dirs WHERE ";

@rel_items = split (/,/, $related_categories);

foreach $item (@rel_items)
	{
	$item =~ s/ //g;
	$related_dirs_sql = $related_dirs_sql . " (cid = '$item') OR";
	}

$related_dirs_sql = substr($related_dirs_sql, 0, length($related_dirs_sql) - 2);

$sth = $dbh->prepare($related_dirs_sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $related_dirs_sql";}
$rows = $sth->rows();

$rc_no = @rel_items;

if ($rc_no != $rows)
	{
	acs::problem_popup("One of the category ID's entered as a 'related category' doesn't exist.");
	}

}


###### ERROR CHECKING
#print "SELECT cid FROM dirs WHERE (lv = '$lv') AND ($qstring)";

$wsql = "SELECT cid FROM dirs WHERE (level = '$lv') AND ($qstring)";
$sth = $dbh->prepare($wsql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $wsql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}

$rows = $sth->rows();
#print "===> $rows <Br><br>";
if ($rows < 1) 
	{
	acs::problem_popup("The category/directory you are trying to save changed - unable to save the changes.
	<a href=\"javascript:onClick=window.close()\">Close</a> this window, refresh it's parent and try again.");
	$sth->finish;
	$dbh->disconnect;
	}



#### IF SET TO BE HIDDEN THEN UPDATE SUB CATEGORIES TO BE HIDDEN AS WELL
$category_status = $q->param('cat_status');
if ($category_status eq "hidden") 
	{
	$sql_h = "UPDATE dirs SET catlock = 'H' WHERE $qstring";
	$sth = $dbh->prepare($sql_h);
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
	}
	elsif (($category_status ne "hidden") and ($q->param('hv') eq "H"))
	{
	$sql_h = "UPDATE dirs SET catlock = '' WHERE $qstring";
	$sth = $dbh->prepare($sql_h);
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
	}




###### UPDATE DIR NAME CHANGES

$lvname = "l" . $lv;

if ($psn ne $directory_name)
	{
	$wsql = "UPDATE dirs SET $lvname = '$directory_name' WHERE $qstring";
	$sth = $dbh->prepare($wsql);
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $wsql"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
	}




if ($category_status eq "locked") { $category_status = "Y"; }
if ($category_status eq "hidden") { $category_status = "H"; }



###### UPDATE DIR NAME CHANGES

$ctemplate = $q->param('ctemplate');

$sth = $dbh->prepare("UPDATE dirs SET 
							  shortname = '$directory_name',
							  ext2 = '$cat_title',
							  description = '$metatag',
							  keywords = '$mkeyw',
							  related1 = '$related_categories',
							  catlock = '$category_status', 
							  template = '$ctemplate'
							WHERE cid = '$cid'
							");
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}


###### IF WE NEED TO UPDATE CUSTOM TEMPLATE FOR PARENT DIRECTORIES

if ($q->param('ctemplate_subs') eq "true")
	{
			@dcats = split(/-/, $ct);
	
			$lvc = 1;
				foreach $item(@dcats)
					{
					$item = acs::decode_dir($item);
					
					$item =~ s/'/\\'/g; 
					$fieldname = "l" . $lvc;
					$where_sql = $where_sql . " ($fieldname = '$item') AND";
					$lvc++;
					}
	
	$where_sql = substr($where_sql, 0, length($where_sql) - 3);
	
	$sql = "UPDATE dirs SET template = '$ctemplate' WHERE $where_sql";	
	$sth = $dbh->prepare($sql);
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

	}


### RECORD CHANGES SO THAT PARENT DIRECTORY CAN BE RE-GENERATED IF ONLY CHANGED HTML ARE GOING TO BE GENERATED

$prev_cid = $q->param('prev_cid');


	$sth = $dbh->prepare("SELECT cid FROM dirs WHERE $qstring");
	
	#print "--> SELECT cid FROM dirs WHERE $qstring<BR>";
	
	if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
	
	open (CFILE, ">> $data_dir/changed_cats.dat");
	
	while ( @row = $sth->fetchrow() )
		{
			print CFILE "$row[0]" . ":\n";	
		}
	
	if ($prev_cid ne "") {	print CFILE "$prev_cid" . ":\n";	 }
	close (CFILE);

$sth->finish;
$dbh->disconnect;


#if ($prev_cid eq "")
#	{
#	open (CFILE, ">> $data_dir/changed_cats.dat");
#		print CFILE "$cid:F\n";
#	close (CFILE);
#	}
#	elsif ($lv == 2)
#	{
#	open (CFILE, ">> $data_dir/changed_cats.dat");
#		print CFILE "$prev_cid" . ":" . "F\n";
#	close (CFILE);
#	}
#	else
#	{
#	open (CFILE, ">> $data_dir/changed_cats.dat");
#		print CFILE "$prev_cid" . ":\n";
#	close (CFILE);
#	}


$saved_box = acs::get_heading_box("$web_url/add.gif", "Changes Saved", qq[You may now <a href="javascript:onClick=window.close()">close</a> this window.]);


print <<END_OF_DC;

<html>
<head>
<title>Changes Saved</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>

<body onUnload="opener.location.reload(true);">

$saved_box

</body>
</html>

END_OF_DC

}






sub edit_dir
{

$ct = $q->param('ct');
$lv = $q->param('lv');
$cid = $q->param('cid');
$prev_cid = $q->param('prev_cid');


### BUILD QUERY STRING

@adirs = split (/-/, $ct);

$lcntr = 1;
foreach $item (@adirs)
	{
	$dsite = acs::decode_dir($item);
	$lstring = $lstring . $dsite . " > ";
	
	$dsite =~ s/'/\\'/g;
	$fname = "l" . $lcntr;
	$qstring = $qstring  . " ($fname = '$dsite') and";
	
	$lcntr++;
	}
	$qstring = substr($qstring, 0, length($qstring) - 3);

###

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$wsql = "SELECT shortname, description, keywords, crosslinkid, related1, catlock, ext2, template FROM dirs WHERE (level = '$lv') AND $qstring";
$sth = $dbh->prepare($wsql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $wsql"; }

$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";} 

$rows = $sth->rows();
if ($rows < 1) 
	{
	acs::problem_popup("The category/directory you are trying to edit, does not exist anymore. 
	<a href=\"javascript:onClick=window.close()\">Close</a> this window, refresh it's parent and try again.");
	$sth->finish;
	$dbh->disconnect;
	}


while ( @row = $sth->fetchrow() )
	{
	$directory_name = $row[0];
	$metatag = $row[1];
	$mkeyw = $row[2];
	$crosslinkid = $row[3];
	$related_categories = $row[4];
	$catlock = $row[5];
	$cat_title = $row[6];
	$hv = $row[5];
	
	$custom_template = $row[7];
	}


if ($crosslinkid > 0)
	{
	$crosslinkid = "<b>$crosslinkid</b><br>This category is a crosslinked to another category. If you want to remove the crosslink, delete this category.";
	}
	else
	{
	
	### RESOLVE RELATED CATEGORIES IF ANY
	if ($related_categories ne "")
		{
		$sql = "SELECT * FROM dirs WHERE ";
		$related_categories =~ s/ //g;
		@rel_items = split (/,/, $related_categories);
			foreach $ritem (@rel_items)
				{
				$sql = $sql . " (cid = '$ritem') OR";
				}
		$sql = substr($sql, 0, length($sql) - 2);
		
		#print "->$sql <Br>";
		
		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

		$related_cats = qq[<span class="normaltext">];
			while ( @row = $sth->fetchrow() )
				{ 
				$cats = "";
				for ($ms = 2; $ms < 18; $ms++) 
					{
					if ($row[$ms] ne "")
						{
						$cats = $cats . $row[$ms] . "/";
						}
					}
				
				$related_cats = $related_cats . "($row[0]) $cats <br>";
				}
		$related_cats = $related_cats . "</span>";
		}


	if ($related_cats ne "")
		{
		$related_cats = acs::get_heading_box("$web_url/add.gif", "Related Directories/Categories", qq[$related_cats]);
		}

	
	#### GET CUSTOM TEMPLATES
	
opendir(DIR,"$data_dir");
	@files = readdir(DIR);
	@files = sort(@files);
	foreach $filename (@files)
		{
		if (substr($filename, length($filename) - 11, 11) eq "-1ctst\.html")
			{
			$cust_tmpl_name = substr($filename, 0, length($filename) - 11);
			
			$selectedv = "";
			if ($custom_template eq $cust_tmpl_name) { $selectedv = "selected"; }
			
			$c_tmpl_options = $c_tmpl_options . qq[<option value="$cust_tmpl_name" $selectedv>$cust_tmpl_name</option>];
			
			}
		} 


	########
	
	if ($catlock eq "Y") { $catlock_yes = "checked"; } 
	elsif ($catlock eq "H") { $hidden_yes = "checked"; } 

	$crosslinkid = "<b>This is not a crosslinked category.</b>";

$no_crosslink = <<END_OF_NC;
  <tr>
    <td bgcolor="#FFFFFF" class="normaltext">Page Title: (Optional)</td>
    <td bgcolor="#FFFFFF" class="normaltext">
      <input type="text" name="cat_title" size="43"
       maxlength="255" value="$cat_title" style="width:100%">
    <br>
    This title can be used as the page title when displaying this category to end users.</td>
  </tr>
  <tr>
    <td bgcolor="#FFFFFF" class="normaltext">Meta Description: (Optional)</td>
    <td bgcolor="#FFFFFF" class="normaltext">
      <input type="text"
      name="metatag" size="43"  value="$metatag" maxlength="255" style="width:100%">
      <br>
    This description will be be used as meta tags for search engines - Max 255 Characters</td>
  </tr>
  <tr>
    <td bgcolor="#FFFFFF" class="normaltext">Meta Keywords: (Optional)</td>
    <td bgcolor="#FFFFFF" class="normaltext">
      <input type="text"
      name="mkeyw" size="43"  value="$mkeyw" maxlength="255" style="width:100%">
      <br>
Fill in keywords seperated by comma's, descriptive of the category. Max 255 Characters.</td>
  </tr>
  <tr>
    <td valign="top" bgcolor="#FFFFFF" class="normaltext">Related Categories/Directories: (Optional)</td>
    <td bgcolor="#FFFFFF" class="normaltext"><input type="text" name="related_categories" size="43"  value="$related_categories" >
        <strong><a href="$admin_url/admin67.cgi" onclick="popup('$admin_url/admin67.cgi?fct=related',750,600);return false;">Browser (To Assign ID's)</a><br>
        </strong>Please specify related category ID's in a comma-separated list above.<br>
        <strong>For example: 10, 313, 423, 35</strong></td>
  </tr>
  <tr>
    <td valign="top" bgcolor="#FFFFFF" class="normaltext">Category/Directory Type:</td>
    <td bgcolor="#FFFFFF" class="normaltext"><table width="100%" border="0" cellpadding="3">
      <tr>
        <td width="15%" class="normaltext"><input type="radio" value="standard" name="cat_status"
     checked>
          <strong>Standard</strong></td>
        <td width="85%" class="normaltext">The
        category is not locked or hidden to end users.&nbsp; </td>
      </tr>
      <tr>
        <td class="normaltext"><input type="radio" value="locked" name="cat_status" $catlock_yes>
          <strong>Locked</strong></td>
        <td class="normaltext">End users are not able to add links to the category.</td>
      </tr>
      <tr>
        <td valign="top" class="normaltext"><input type="radio" value="hidden" name="cat_status" $hidden_yes>
          <strong>Hidden</strong></td>
        <td class="normaltext"><strong> </strong>This category will not be displayed to end users. <br>
          &nbsp;(Note that it's sub categories will also be set to be hidden)<br></td>
      </tr>
    </table>
      </td>
  </tr>
 
  <tr>
       <td valign="top" bgcolor="#FFFFFF" class="normaltext">Custom Category Template:</td>
       <td bgcolor="#FFFFFF" class="normaltext"><label>
         <select name="ctemplate" id="ctemplate">
           <option value="">Default</option>
           $c_tmpl_options
         </select>
         
          <input name="ctemplate_subs" type="checkbox" id="ctemplate_subs" value="true">
          <b>Assign this template to all sub categories/directories of this category/directory?</b>
         <br>
       You can create custom category templates by clicking the 'Template Manager' tab in the Control Panel. Scroll down and click on 'Create or Edit Custom Directory/Category Templates'. Custom category templates enables you to give specific categories an original look and feel or target advertisements or specific content at specific categories.</label></td>
    </tr>
 
END_OF_NC
	}





#$crosslinkid

$lstring = "Root > " . substr($lstring, 0, length($lstring) - 2); 


$headingd = acs::get_heading_box("$web_url/add.gif", "Edit Category/Directory", qq[<b>Location:</b> $lstring]);
	


print <<END_OF_EDIT;

<html>
<head>
<title>Edit Directory</title>

<script LANGUAGE="JavaScript">
<!-- Hide

  function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);
    var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=" + mywidth + ",height=" + myheight + "'";
	var random = parseInt(Math.random()*10000)

	  var popupwin = null;
      myWindow = open (loc, popupwin + random, myspecs);
      myWindow.moveTo(400,0);
      myWindow.focus();

    }
 // End Hide -->
 </script>

<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>


$headingd



<form method="POST" action="$admin_url/admin2.cgi" name="addu">
  <table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#E1E1E1">
  <tr>
    <td colspan="2" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Category/Directory Details:</strong></td>
    </tr>
  <tr>
    <td width="27%" bgcolor="#FFFFFF" class="normaltext">Category/Directory Name:</td>
    <td width="73%" bgcolor="#FFFFFF" class="normaltext">
      <input type="text"
      name="directory_name" size="43" 
      maxlength="100" value="$directory_name" style="width:100%">    </td>
  </tr>
  <tr>
    <td bgcolor="#FFFFFF" class="normaltext"  valign="top">Crosslink Category/Directory ID:</td>
    <td bgcolor="#FFFFFF" class="normaltext">$crosslinkid</td>
  </tr>
$no_crosslink
  <tr>
    <td valign="top" bgcolor="#FFFFFF" class="normaltext">&nbsp;</td>
    <td bgcolor="#FFFFFF" class="normaltext">
      <input type="submit"
      value="   Save   " name="B2" >
      <input type="hidden" name="ct" value="$ct">
      <input type="hidden" name="fct" value="edit_dir_final">
      <input type="hidden" name="lv" value="$lv">
      <input type="hidden" name="cid" value="$cid">
      <input type="hidden" name="prev_cid" value="$prev_cid">
      <input type="hidden" name="hv" value="$hv">    </td>
  </tr>
</table>
<div align="center"><center>
    <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr><td width="1%" bgcolor="#FFFFFF"></td><td width="99%"></td></tr>
  </table>

  </center></div>
  <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
  </table>
</form>


$related_cats


</body>
</html>
  
END_OF_EDIT

$sth->finish;
$dbh->disconnect;

}





sub add_dir_final
{

$mscr = $q->param('mscr');

$dirname = $q->param('directory_name');
$dirname =~ s/_/ /g;
$dirname =~ s/\\//g;
$dirname = acs::remove_leading_spacing($dirname);

$cat_title = $q->param('cat_title');
$cat_title =~ s/'/\\'/g;

$metadiz = $q->param('metatag');
$metadiz =~ s/'/\\'/g;

$metakeyw = $q->param('mkeyw');
$metakeyw =~ s/'/\\'/g;

$shortname = $dirname;

$ct = $q->param('ct');
$orig_ct = $ct;

$lv = $q->param('lv');

$custom_template = $q->param('ctemplate');


#$locked = $q->param('locked');
#if ($locked eq 


$catstat = $q->param('cat_status');
if ($catstat eq "locked") { $cat_status = "Y"; }
if ($catstat eq "hidden") { $cat_status = "H"; }


if ($lv eq "") {$lv = 1;}
elsif ($lv == 0) {$lv = 1;}
else {$lv++;}

#### CHECK IF SOMETHING SPECIFIED

if ($dirname eq ""){acs::problem_popup("You have to supply a name for the directory you are about to create.");}


###########

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }




if ($ct eq "")
	{
	$adir[0] = "$dirname";
	}
	else
	{
	#$rct = acs::decode_dir($ct);
	@adir = split (/-/, $ct);

	$acn = 0;
	foreach $ditem (@adir)
		{
		$currend_decoded = acs::decode_dir($ditem);
		$fname = "l" . ($acn + 1);
		$adir[$acn] = $currend_decoded;
		$acn++;
		
		$currend_decoded =~ s/'/\\'/g;
		$qstring = $qstring  . " ($fname = '$currend_decoded') AND";
		}
	
	$apos = $lv; $apos = $apos - 1;
	$adir[$apos] = $dirname;
	
	### CHECK IF CATEGORY EXISTS
		$qstring = substr($qstring, 0, length($qstring) - 3);
		
		$curr_lv = $lv - 1;
		
		$wsql = "SELECT cid FROM dirs WHERE (level = '$curr_lv') AND ($qstring)";
		$sth = $dbh->prepare($wsql);
		if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $wsql"; }
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";} 
		$rows = $sth->rows();
		while ( @row = $sth->fetchrow() )
			{
			$current_cat_cid = $row[0];
			}

		if ($rows < 1) 
		{
		acs::problem_popup("The category/directory you are trying to add a new directory/category to, changed - unable to save the changes. 
		<a href=\"javascript:onClick=window.close()\">Close</a> this window, refresh it's parent and try again.");
		$sth->finish;
		$dbh->disconnect;
		}
		$qstring = "";
	}



### DUPLICATE CHECKING ################
	$dn2 = $dirname;
	$dn2 =~ s/'/\\'/g;
	
	@adirs = split (/-/, $ct);
	$nrdirs = @adirs; #$nrdirs = $nrdirs - 1;

	for ($ms = 0; $ms < $nrdirs; $ms++) 
		{
		$acnt = $ms + 1;
		
		$adirs[$ms] = acs::decode_dir($adirs[$ms]);
		$adirs[$ms] =~ s/'/\\'/g;
		$querystr = $querystr . " (l" . "$acnt = '$adirs[$ms]') and";
		}
		$querystr = substr($querystr, 0, length($querystr) - 3);
		$acnt++;
		
		if ($acnt > 16) { acs::problem_popup("The maximum number of nested levels you may have is 16."); }
		
		if ($querystr ne "")
			{
			$querystr = $querystr . " and (l" . $acnt . " = '$dn2')";
			}
			else
			{
			$querystr = $querystr . "(l" . $acnt . " = '$dn2')";
			}
	
	
	
	$wsql = "SELECT shortname FROM dirs WHERE $querystr";
	
	#print "$acnt - $wsql";
	
	$sth = $dbh->prepare($wsql);
	if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";} 
	$rows = $sth->rows();
	
	if (($rows > 0) and ($rows < 10000)) {acs::problem_popup("The name of the directory you are trying to add already exists.");}



### IF THIS IS A CROSSLINKED CATEGORY, THEN CHECK IF CATEGORY ID EXISTS

$crosslinkid = $q->param('crosslinkid');

if ($crosslinkid ne "")
{

$sql_crossl = "SELECT cid FROM dirs WHERE cid = '$crosslinkid'";
$sth = $dbh->prepare($sql_crossl);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql_crossl";}
$rows = $sth->rows();

if ($rows < 1) { acs::problem_popup("The crosslink category ID you provided could not be found in the database."); }

$crosslinkid = ",crosslinkid 	= '$crosslinkid'"; 
}



### IF THERE IS RELATED CATEGORIES ASSOCIATED WITH THIS CATEGORY - CHECK IF THEY EXIST

$related_categories = $q->param('related_categories');
if (($crosslinkid eq "") and ($related_categories ne ""))
{

$related_dirs_sql = "SELECT cid FROM dirs WHERE ";

@rel_items = split (/,/, $related_categories);

foreach $item (@rel_items)
	{
	$item =~ s/ //g;
	$related_dirs_sql = $related_dirs_sql . " (cid = '$item') OR";
	}

$related_dirs_sql = substr($related_dirs_sql, 0, length($related_dirs_sql) - 2);

#print "===> $related_dirs_sql <br>";

$sth = $dbh->prepare($related_dirs_sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $related_dirs_sql";}
$rows = $sth->rows();

$rc_no = @rel_items;

if ($rc_no != $rows)
	{
	acs::problem_popup("One of the category ID's you entered as a related category doesn't exist.");
	}

$related_categories = ",related1 = '$related_categories'"; 

}


### ADD DIR ###########################

$adir[0] =~ s/'/\\'/g; $adir[1] =~ s/'/\\'/g;  $adir[2] =~ s/'/\\'/g;  $adir[3] =~ s/'/\\'/g;  $adir[4] =~ s/'/\\'/g; 
$adir[5] =~ s/'/\\'/g; $adir[6] =~ s/'/\\'/g;  $adir[7] =~ s/'/\\'/g;  $adir[8] =~ s/'/\\'/g;  $adir[9] =~ s/'/\\'/g; 
$adir[10] =~ s/'/\\'/g; $adir[11] =~ s/'/\\'/g;  $adir[12] =~ s/'/\\'/g;  $adir[13] =~ s/'/\\'/g;  $adir[14] =~ s/'/\\'/g; 
$adir[15] =~ s/'/\\'/g; $adir[16] =~ s/'/\\'/g; 
$shortname =~ s/'/\\'/g;

$related_categories =~ s/ //g;

if ($crosslinkid ne "") { $related_categories = ""; }

$sth = $dbh->prepare("INSERT INTO dirs SET 
		level				= '$lv',
		
		l1 				= '$adir[0]',
		l2				 	= '$adir[1]',
		l3			 		= '$adir[2]',
		l4		 			= '$adir[3]',
		l5					= '$adir[4]',
		l6					= '$adir[5]',
		l7					= '$adir[6]', 
		l8					= '$adir[7]', 
		l9					= '$adir[8]',
		l10				= '$adir[9]',
		l11				= '$adir[10]',
		l12				= '$adir[11]',
		l13				= '$adir[12]',
		l14				= '$adir[13]',
		l15				= '$adir[14]',
		l16				= '$adir[15]',

		linknrs 			= '0',
		ext2				= '$cat_title',
		description		= '$metadiz',
		keywords			= '$metakeyw',
		shortname		= '$shortname',
		catlock 			= '$cat_status',
		template 		= '$custom_template'
		$crosslinkid
		$related_categories
		");


if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}


### GET LAST INSERTED ID
$sth = $dbh->prepare("SELECT cid FROM dirs WHERE cid = LAST_INSERT_ID()");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
while ( @row = $sth->fetchrow() )	
	{
	$last_id = $row[0];
	}  

$sth->finish;
$dbh->disconnect;


######################################################
$lv = $lv - 1;


#if ($mscr eq "mscr")
#	{
#	$bodytag = 	"<body onUnload=\"opener.location.reload(true);\">";
#	}
#	else
#	{
#	$bodytag = "<body>";
#	}



### UPDATE CHANGE FILE SO THAT ONLY CHANGED CATEGORIES GET UPDATED FOR CHANGED HTML GENERATION
if ($lv ==0)
	{
	open (CFILE, ">> $data_dir/changed_cats.dat");
		print CFILE "$last_id" . ":" . "\n";
	close (CFILE);
	}
elsif (($lv == 1) or ($lv == 2))
	{
	open (CFILE, ">> $data_dir/changed_cats.dat");
		print CFILE "$current_cat_cid" . ":" . "F\n";
		print CFILE "$last_id" . ":" . "\n";
	close (CFILE);
	}
	else
	{
	open (CFILE, ">> $data_dir/changed_cats.dat");
		print CFILE "$current_cat_cid" . ":\n";
		print CFILE "$last_id" . ":" . "\n";
	close (CFILE);
	}



$hbox = acs::get_heading_box("$web_url/add.gif", "New Category/Directory Created", qq[    Click <a
    href="$admin_url/admin2.cgi?fct=addir&amp;ct=$ct&amp;lv=$lv&mscr=$mscr"><strong>here to add</strong></a> another
    directory or <a href="javascript:onClick=window.close()"><strong>here to close</strong></a> this window.
]);

print <<END_OF_DC;

<html>

<head>
<title>Directory Added</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>

<body onUnload="opener.location.reload(true);">
$hbox

</body>
</html>


END_OF_DC

}






sub addir
{
$ct = $q->param('ct');
$lv = $q->param('lv');

$mscr = $q->param('mscr');

$template_cust = $q->param('cust_tmpl');

### GET CUSTOM CATEGORY TEMPLATES


opendir(DIR,"$data_dir");
	@files = readdir(DIR);
	@files = sort(@files);
	foreach $filename (@files)
		{
		if (substr($filename, length($filename) - 11, 11) eq "-1ctst\.html")
			{
			$cust_tmpl_name = substr($filename, 0, length($filename) - 11);
			
				if ($template_cust eq $cust_tmpl_name)
					{
					$ctemplates_avail = $ctemplates_avail . qq[<option value="$cust_tmpl_name" selected>$cust_tmpl_name</option>];
					}
					else
					{
					$ctemplates_avail = $ctemplates_avail . qq[<option value="$cust_tmpl_name">$cust_tmpl_name</option>];
					}
			
			}
		} 




if ($lv eq "") { $lv = "0";}

$location = acs::get_location_string($ct);


$hbox = acs::get_heading_box("$web_url/add.gif", "Add a New Directory/Category", qq[Add a New Category/Directory To: <b>$location</b>]);


print <<END_OF_ADD;
<html>
<head>
<title>Add a New Directory</title>
<script LANGUAGE="JavaScript">
<!-- Hide

  function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);
    var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=" + mywidth + ",height=" + myheight + "'";
	var random = parseInt(Math.random()*10000)

	  var popupwin = null;
      myWindow = open (loc, popupwin + random, myspecs);
      myWindow.moveTo(400,0);
      myWindow.focus();

    }
 // End Hide -->
 </script>
 <link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>

$hbox






<form method="POST" action="$admin_url/admin2.cgi" name="addu">
  <table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#DDDDDD">
    <tr>
      <td height="30" colspan="2" valign="top" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Category/Directory Details:</strong></td>
    </tr>
    <tr>
      <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext"> Category Name:</td>
      <td width="75%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="directory_name" size="43" maxlength="100" style="width:100%"></font><br>
      Max 255 Characters</td>
    </tr>
    <tr>
      <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext">Crosslink Category ID: (Optional)</td>
      <td width="75%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="crosslinkid" size="7"> <strong><a
      href="$admin_url/admin67.cgi" onClick="popup('$admin_url/admin67.cgi',750,600);return false;">Browser</a> </strong><br>
      If this is a crosslinked category (symbolic
      link to another category), specify the ID of the existing category to link this category
      to. You can view category IDs or assign a category ID by clicking the browse button. Note
      that none of the settings below (meta details and related categories) will have any effect
      if this category is a symbolic/crosslinked category.</td>
    </tr>
    <tr>
      <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext"> Title:  (Optional)</td>
      <td width="75%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="cat_title" size="43" 
      maxlength="255" style="width:100%">
        This title can be used as the page title when displaying this category to end users.<br>
      <strong>If this is a crosslinked category, then this text has no effect.</strong></td>
    </tr>
    <tr>
      <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext"> Meta Description: (Optional)</td>
      <td width="75%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="metatag" size="43" maxlength="255" style="width:100%">
      This description will be be used as meta tags for search engines - Max 255 Characters<br>
      <strong>If this is a crosslinked category, then this text has no effect.</strong></td>
    </tr>
    <tr>
      <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext"> Meta Keywords: (Optional)</td>
      <td width="75%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="mkeyw" size="43" maxlength="255" style="width:100%">
        Fill in keywords separated by comma's, descriptive of the category. Max 255 Characters.<br>
      <strong>If this is a
      crosslinked category, then this text has no effect.</strong></td>
    </tr>
    <tr>
      <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext"> Related Categories: (Optional)</td>
      <td width="75%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="related_categories" size="43"> <strong><a
      href="$admin_url/admin67.cgi" onClick="popup('$admin_url/admin67.cgi?fct=related',750,600);return false;">Browser</a><br>
      </strong>Please specify related category ID's in a comma separated list above.<br>
      <strong>For example: 10, 313, 423, 35</strong><br>
      You can view the category ID's by browsing directories in the 'Dir Manager'. When you move
      your mouse over a category (In the Dir Manager) the statusbar of your browser will
      indicate the ID of the category.<br>
      <strong>If this is a crosslinked category, then this has no effect.</strong></td>
    </tr>
    <tr>
      <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext"> Category Status:</td>
      <td width="75%" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="standard" name="cat_status"
      checked> <strong>Standard </strong>- The
      category is not locked or hidden to end users.&nbsp; <br>
      <input type="radio" value="locked" name="cat_status"> <strong>Locked - </strong>End users are not able to add links to the category.
      &nbsp; <br>
      <input type="radio" value="hidden" name="cat_status"> <strong>Hidden - </strong>This category will not be displayed to end users.<br>      </td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext">Custom Category Template:</td>
      <td bgcolor="#FFFFFF" class="normaltext"><label>
        <select name="ctemplate" id="ctemplate">
          <option>Default</option>
			$ctemplates_avail          
        </select>
        <br>
      You can create custom category templates by clicking the 'Template Manager' tab in the Control Panel. Scroll down and click on 'Create or Edit Custom Directory/Category Templates'. Custom category templates enables you to give specific categories an original look and feel or target advertisements or specific content at specific categories.</label></td>
    </tr>
    <tr>
      <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </td>
      <td width="75%" bgcolor="#FFFFFF" class="normaltext"><input type="submit"
      value="   Add New Directory  " name="B2">
        <input type="hidden" name="fct" value="add_dir_final">
        <input type="hidden" name="ct"
  value="$ct">
        <input type="hidden" name="lv" value="$lv">
      <input type="hidden" name="mscr"
  value="$mscr"></td>
    </tr>
  </table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>
</form>




</body>
</html>

END_OF_ADD

}







sub manage_dirs
{


$template = acs::get_template("DIR_MANAGER");

if ($gsettings->{searchmeth} eq "fulltext")
	{
	$template =~ s/!!!search!!!/search2\.cgi/g;
	}
	else
	{
	$template =~ s/!!!search!!!/search\.cgi/g;
	}

$cid = $q->param('cid');
$rid = $q->param('rid');

##### LEVEL

$lv = $q->param('lv');
$rlv = $lv;
if ($lv eq "") { $lv = 0; }

$ct = $q->param('ct');

###### DIR OPTIONS
if ($q->param('ct') eq "")
	{
$toplinks = <<ENDTP;

<table width="100%" cellspacing="0" cellpadding="0">
  <tr>
    <td width="1"><img src="$web_url/dbut.gif"></td>
    <td width="97%" height="40"><a href="$admin_url/admin2.cgi?fct=addir&amp;ct=$ct&amp;lv=$lv"
    onClick="popup('$admin_url/admin2.cgi?fct=addir&amp;ct=$ct&amp;lv=$lv',screen.width-200,screen.height-200);return false;"><img
    src="$web_url/d_addir.gif" border="0"></a><a
    href="$admin_url/admin2.cgi?fct=addir_m&amp;ct="
    onClick="popup('$admin_url/admin2.cgi?fct=addir_m&amp;ct=',screen.width-200,screen.height-200);return false;"><img
    src="$web_url/d_addirm.gif" border="0"></a><a href="$admin_url/admin8.cgi"
    onClick="popup('$admin_url/admin8.cgi',750,600);return false;"><img
    src="$web_url/generate.gif" border="0"></a></td>
  </tr>
</table>

ENDTP

#<a href="$admin_url/admin33.cgi" onClick="popup('$admin_url/admin33.cgi',600,400);return false;"><img src="$web_url/emailb.gif" border="0"></a>


	}
	else
	{






$toplinks = <<ENDTP;

<table width="100%" cellspacing="0" cellpadding="0">
  <tr>
    <td width="1"><img src="$web_url/dbut.gif"></td>
    <td width="85%" valign="bottom"><a
    href="$admin_url/admin2.cgi?fct=addir&amp;ct=$ct&amp;lv=$lv&amp;cust_tmpl=!!cust_template!!"
    onClick="popup('$admin_url/admin2.cgi?fct=addir&amp;ct=$ct&amp;lv=$lv&amp;cust_tmpl=!!cust_template!!',screen.width-200,screen.height-200);return false;"><img
    src="$web_url/d_addir.gif" border="0"></a><a
    href="$admin_url/admin2.cgi?fct=addir_m&amp;ct=$ct&amp;lv=$lv&amp;cid=$cid&amp;cust_tmpl=!!cust_template!!"
    onClick="popup('$admin_url/admin2.cgi?fct=addir_m&amp;ct=$ct&amp;lv=$lv&amp;cid=$cid&amp;cust_tmpl=!!cust_template!!',screen.width-200,screen.height-200);return false;"><img
    src="$web_url/d_addirm.gif" border="0"></a><a
    href="$admin_url/admin4.cgi?fct=add_listing&amp;ct=$ct&amp;lv=$lv&amp;cid=$cid&amp;rid=$rid"
    onClick="popup('$admin_url/admin4.cgi?fct=add_listing&amp;ct=$ct&amp;lv=$lv&amp;cid=$cid&amp;rid=$rid',screen.width-200,screen.height-200);return false;"><img
    src="$web_url/d_addlink.gif" border="0"></a><a
    href="$admin_url/admin4.cgi?fct=add_listing_m&amp;ct=$ct&amp;lv=$lv&amp;cid=$cid&amp;rid=$rid"
    onClick="popup('$admin_url/admin4.cgi?fct=add_listing_m&amp;ct=$ct&amp;lv=$lv&amp;cid=$cid&amp;rid=$rid',screen.width-200,screen.height-200);return false;"><img
    src="$web_url/d_addlink2.gif" border="0"></a><a
    href="$admin_url/admin38.cgi?ct=$ct&amp;lv=$lv&amp;cid=$cid&amp;rid=$rid"
    onClick="popup('$admin_url/admin38.cgi?ct=$ct&amp;lv=$lv&amp;cid=$cid&amp;rid=$rid',screen.width-200,screen.height-200);return false;"><img
    src="$web_url/i_import.gif" border="0"></a><a
    href="$admin_url/admin41.cgi?cid=$cid&amp;ct=$ct"
    onClick="popup('$admin_url/admin41.cgi?cid=$cid&amp;ct=$ct',screen.width-200,screen.height-200);return false;"><img
    src="$web_url/i_crawl.gif" border="0"></a><a
    href="$admin_url/odp.cgi?ct=$ct&amp;lv=$lv&amp;cid=$cid&amp;rid=$rid"
    onClick="popup('$admin_url/odp.cgi?ct=$ct&amp;lv=$lv&amp;cid=$cid&amp;rid=$rid',screen.width-200,screen.height-200);return false;"><img
    src="$web_url/i_odp.gif" border="0"></a><a
    href="$admin_url/generate.cgi?fct=part_build&amp;cid=$cid"
    onClick="popup('$admin_url/generate.cgi?fct=part_build&amp;cid=$cid',750,600);return false;"><img
    src="$web_url/generate.gif" border="0"></a> </td>
    <td width="15%" valign="middle" align="right"><span class="normaltext"><b>!!expand_retract!!</b></span></td>
  </tr>
</table>
   
ENDTP
	}

#    <a href="$admin_url/admin33.cgi?cid=$cid"   onClick="popup('$admin_url/admin33.cgi?cid=$cid',600,400);return false;"><img src="$web_url/emailb.gif" border="0"></a> 


##### TOP LINKS
#$rdata = <<END_OF_RPLD;
#<strong><font face="Arial" size="4">Directory Manager</font></strong>
#END_OF_RPLD


##### RETRIEVE DIRS
if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password) || die "Database connection not made: $DBI::errstr";


if ($lv == 0)
	{
	$sth = $dbh->prepare("SELECT * FROM dirs WHERE (level = '1') ORDER BY shortname ASC");
	}
	else
	{
	$lv++;
	@adir = split (/-/, $ct);
	#$rct = acs::decode_dir($ct);
	
	$querystr = "";

	for ($ms = 0; $ms < 16; $ms++) 
		{
		if ($adir[$ms] ne "") {$adir[$ms] = acs::decode_dir($adir[$ms]);}

		$acnt = $ms + 1;
		if ($acnt != $lv)
			{
			if ($adir[$ms] ne "")
				{
				$adir[$ms] =~ s/'/\\'/g;
				}
			$querystr = $querystr . " (l" . "$acnt = '$adir[$ms]') and";
			}
		$acnt++;
		}
	$querystr = substr($querystr, 0, length($querystr) - 3);
	$sth = $dbh->prepare("SELECT * FROM dirs WHERE (level = '$lv') and $querystr ORDER BY shortname ASC");
	
	#print "--> SELECT * FROM dirs WHERE (level = '$lv') and $querystr ORDER BY shortname ASC <BR>";
	}
	
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
$rows = $sth->rows();

#print "$rows <BR>";

if ($rid ne "") {$rid = $rid . "-"; }

### 
$nowtime = time();

while ( @row = $sth->fetchrow() )
	{
	## $row[29]
	
	$cust_template = $row[27];
	
	$lv = $row[1];
	
	$row[2] = acs::encode_dir($row[2]); $dirstring = $row[2];														#1
	if ($row[3] ne "") { $row[3] = acs::encode_dir($row[3]); $dirstring =   $dirstring . "-$row[3]"; } #2
	if ($row[4] ne "") { $row[4] = acs::encode_dir($row[4]); $dirstring =   $dirstring . "-$row[4]"; } #3
	if ($row[5] ne "") { $row[5] = acs::encode_dir($row[5]); $dirstring =   $dirstring . "-$row[5]"; } #4
	if ($row[6] ne "") { $row[6] = acs::encode_dir($row[6]); $dirstring =   $dirstring . "-$row[6]"; } #5
	if ($row[7] ne "") { $row[7] = acs::encode_dir($row[7]); $dirstring =   $dirstring . "-$row[7]"; } #6
	if ($row[8] ne "") { $row[8] = acs::encode_dir($row[8]); $dirstring =   $dirstring . "-$row[8]"; } #7
	if ($row[9] ne "") { $row[9] = acs::encode_dir($row[9]); $dirstring =   $dirstring . "-$row[9]"; } #8
	
	if ($row[10] ne ""){ $row[10] = acs::encode_dir($row[10]); $dirstring = $dirstring ."-$row[10]";} #9
	if ($row[11] ne ""){ $row[11] = acs::encode_dir($row[11]); $dirstring = $dirstring ."-$row[11]"; } #10
	if ($row[12] ne ""){ $row[12] = acs::encode_dir($row[12]); $dirstring = $dirstring ."-$row[12]"; } #11
	if ($row[13] ne ""){ $row[13] = acs::encode_dir($row[13]); $dirstring = $dirstring ."-$row[13]"; } #12
	if ($row[14] ne ""){ $row[14] = acs::encode_dir($row[14]); $dirstring = $dirstring ."-$row[14]"; } #13
	if ($row[15] ne ""){ $row[15] = acs::encode_dir($row[15]); $dirstring = $dirstring ."-$row[15]"; } #14
	if ($row[16] ne ""){ $row[16] = acs::encode_dir($row[16]); $dirstring = $dirstring ."-$row[16]"; } #15
	if ($row[17] ne ""){ $row[17] = acs::encode_dir($row[17]); $dirstring = $dirstring ."-$row[17]"; } #16

	if ($row[20] eq "") { $row[20] = 0; }

	if ($row[27] eq "") { $row[27] = "Default"; }
	
	if (($row[30] eq "") and ($row[31] eq "") and ($row[32] eq "") and ($row[33] eq "") and ($row[34] eq "")) 
		{
		$bannerstat = "None";
		}
		else
		{
		$bannerstat = "Defined";
		}
	
	if ($row[29] > 0) ### IF THIS IS A CROSSLINKED CATEGORY
		{
		$cross_linksqlw = $cross_linksqlw . " (cid = '$row[29]') OR"; 

		if ($colcnt > 0) 
			{
			$colcolor = "#F9F9F9"; $colcnt = 0;
			}
			else
			{
			$colcolor = "#FFFFFF"; $colcnt++;
			}
	
	
$dirtable_middle = $dirtable_middle . <<ENDMT_CLINK;
 <tr>
    <td width="48%" bgcolor="$colcolor" height="30"><span class="normaltext"><strong><img src="$web_url/dircross.gif"><a href="-$row[29]-CRSLINK">$row[28]</a></strong> @ (-$row[29]-CRSLCNTS)</span></td>
    <td width="18%" bgcolor="$colcolor"><p align="center"><a href="$admin_url/admin2.cgi?fct=edit_dir&amp;lv=$lv&amp;ct=$dirstring&amp;cid=$row[0]&amp;prev_cid=$cid" onClick="popup('$admin_url/admin2.cgi?&amp;fct=edit_dir&amp;lv=$lv&amp;ct=$dirstring&amp;cid=$row[0]&amp;prev_cid=$cid',screen.width -200,300);return false;"><span class="normaltext">Edit</a> 
    | Move | <a href="$admin_url/admin2.cgi?&amp;fct=delete_dir&amp;lv=$lv&amp;ct=$dirstring&amp;cid=$row[0]&amp;crossl=true&amp;prev_cid=$cid" onClick="popup('$admin_url/admin2.cgi?&amp;fct=delete_dir&amp;lv=$lv&amp;ct=$dirstring&amp;cid=$row[0]&amp;$row[0]&amp;crossl=true&amp;prev_cid=$cid',750,600);return false;">Delete</span></a></td>
    <td width="9%" bgcolor="$colcolor"><p align="center"><span class="normaltext">Generate</span></td>
    <td width="9%" bgcolor="$colcolor"><p align="center"><a href="$admin_url/admin31.cgi?cid=$row[29]" onClick="popup('$admin_url/admin31.cgi?cid=$row[29]',750,600);return false;"><span class="normaltext">$bannerstat</span></a></td>
    <td width="9%" bgcolor="$colcolor"><p align="center"><a href="$admin_url/admin28.cgi?cid=$row[29]" onClick="popup('$admin_url/admin28.cgi?cid=$row[29]',750,600);return false;"><span class="normaltext">$row[27]</span></a></td>
    <td width="9%" bgcolor="#F2F9FF"><p align="center"><a href="-$row[29]-PRVLINK" target="_blank"><span class="normaltext">Preview</span></a></td>
  </tr>
ENDMT_CLINK
		}
		else
		{
		#print "==> $nowtime <BR>";
		
		$catlock = "";  $fontcolor = ""; $fontcolor2 = "";
		if ($row[22] eq "Y") { $catlock = "<img src=\"$web_url/locked.gif\">"; } 
		if ($row[22] eq "H") { $fontcolor = "<font color=\"#808080\">"; $fontcolor2 = "</font>";}
		
		### CHECK IF NEW1
		$newgif = "";
		$new1secs = $gsettings->{days1} * 86400;
		$new1time = $nowtime - $new1secs;
		if ($row[23] > $new1time)
			{
			$newgif = "<img src=\"$web_url/new1.gif\">";
			}
		
		### CHECK IF NEW2
		if ($newgif eq "")
		{
		$new1secs = $gsettings->{days2} * 86400;
		$new1time = $nowtime - $new1secs;
		if ($row[23] > $new1time)
			{
			$newgif = "<img src=\"$web_url/new2.gif\">";
			}
		}
		
		### CHECK IF NEW3
		if ($newgif eq "")
		{
		$new1secs = $gsettings->{days3} * 86400;
		$new1time = $nowtime - $new1secs;
		if ($row[23] > $new1time)
			{
			$newgif = "<img src=\"$web_url/new3.gif\">";
			}
		}


if ($colcnt > 0) 
	{
	$colcolor = "#F9F9F9"; $colcnt = 0;
	}
	else
	{
	$colcolor = "#FFFFFF"; $colcnt++;
	}


if ($row[22] eq "H")
	{
	$genlink = qq[Generate];
	} 
	else
	{ 
	$genlink = qq[<a href="$admin_url/generate.cgi?fct=part_build&amp;cid=$row[0]" onClick="popup('$admin_url/generate.cgi?fct=part_build&amp;cid=$row[0]',750,600);return false;">Generate</a>];
	}


#### DISPLAY CATEGORIES
$dirtable_middle = $dirtable_middle . <<ENDMT;
  <tr>
    <td width="48%" bgcolor="$colcolor" height="30"><span class="normaltext"><strong><img src="$web_url/subdir.gif"> <a href="$admin_url/admin2.cgi?lv=$lv&amp;ct=$dirstring&amp;cid=$row[0]&amp;rid=$rid$row[0]">$fontcolor $row[28]$fontcolor2</a></strong> ($row[20]) $catlock $newgif</span></td>
	 <td width="18%" bgcolor="$colcolor"><p align="center"><span class="normaltext"><a href="$admin_url/admin2.cgi?fct=edit_dir&amp;lv=$lv&amp;ct=$dirstring&amp;cid=$row[0]&amp;prev_cid=$cid" onClick="popup('$admin_url/admin2.cgi?&amp;fct=edit_dir&amp;lv=$lv&amp;ct=$dirstring&amp;cid=$row[0]&amp;prev_cid=$cid',screen.width -200,screen.height -300);return false;">Edit</a> 
	 | <a href="$admin_url/admin62.cgi?lv=$lv&amp;ct=$dirstring&amp;cid=$row[0]&amp;&amp;rid=$rid$row[0]&amp;prev_cid=$cid" onClick="popup('$admin_url/admin62.cgi?lv=$lv&amp;ct=$dirstring&amp;cid=$row[0]&amp;rid=$rid$row[0]&amp;prev_cid=$cid',screen.width -200,screen.height -300);return false;">Move</a> 
	 | <a href="$admin_url/admin2.cgi?&amp;fct=delete_dir&amp;lv=$lv&amp;ct=$dirstring&amp;cid=$row[0]&amp;&amp;rid=$rid$row[0]&amp;prev_cid=$cid" onClick="popup('$admin_url/admin2.cgi?&amp;fct=delete_dir&amp;lv=$lv&amp;ct=$dirstring&amp;cid=$row[0]&amp;rid=$rid$row[0]&amp;prev_cid=$cid',750,400);return false;">Delete</a></span></td>
    <td width="9%" bgcolor="$colcolor"><p align="center"><span class="normaltext">$genlink</span></td>
    <td width="9%" bgcolor="$colcolor"><p align="center"><span class="normaltext"><a href="$admin_url/admin31.cgi?cid=$row[0]" onClick="popup('$admin_url/admin31.cgi?cid=$row[0]',750,600);return false;">$bannerstat</a></span></td>
    <td width="9%" bgcolor="$colcolor"><p align="center"><span class="normaltext"><a href="$admin_url/admin28.cgi?cid=$row[0]" onClick="popup('$admin_url/admin28.cgi?cid=$row[0]',750,600);return false;">$row[27]</a></span></td>
    <td width="9%" bgcolor="#F2F9FF"><p align="center"><span class="normaltext"><a href="$script_url/dirs.cgi?lv=$lv&amp;ct=$dirstring&amp;cid=$row[0]&amp;rid=$rid$row[0]" target="_blank">Preview</a></span></td>
  </tr>
ENDMT

		}



	$curcidi = $row[0];
	}

### GET CROSSLINKS IF ANY

if ($cross_linksqlw ne ""){&get_crosslinks;} 


#### GET LINKS

$exp_ext = acs::get_file_contents("$data_dir/expext.dat");
if ($exp_ext eq "retract")
	{
	$sth = $dbh->prepare("SELECT COUNT(*) FROM links WHERE cid = '$cid'");
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
	while ( @row = $sth->fetchrow() ){$total_links = $row[0];}
	
	$expand_extract = qq[<a href="$admin_url/admin59.cgi?fct=retract" onClick="popup('$admin_url/admin59.cgi?fct=retract',500,300);return false;">Expand Links</a>];
	
	$retract_box = qq[
<BR>
<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#C0C0C0">
  <tr>
    <td bgcolor="#FFFFFF" width="766" valign="top"><p align="center">Note that links has been <b>set to be retracted</b>. This means that links will not
    display in the Directory Manager. Click the 'Expand Links' to the right to have links
    display inside the Directory Manager. In some situations not displaying links makes it
    fast to browse the Directory Manager and work with categories/directories.</td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>
	
	]
	}
	else
	{
	&get_links;
	$expand_extract = qq[<a href="$admin_url/admin59.cgi?fct=expand" onClick="popup('$admin_url/admin59.cgi?fct=expand',500,300);return false;">Retract Links</a>];
	}


#### LOCATION
$nria = @adir;



if ($nria != 0)
	{
	
	
	
	
	$lcstring = $lcstring . "<font color=\"#0080FF\"> <b>Location: <img src=\"$web_url/loc.gif\"></b>&nbsp;&nbsp;</font> <a href=\"$admin_url/admin2.cgi\">Root</a> ";
	}
	else
	{

	$sth = $dbh->prepare("SELECT COUNT(*) FROM links");
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
	while ( @row = $sth->fetchrow() ){$links_t = $row[0];}

	$sth = $dbh->prepare("SELECT COUNT(*) FROM dirs");
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
	while ( @row = $sth->fetchrow() ){$dirs_t = $row[0];}
	
	$lcstring = $lcstring . qq[<font color="#0080FF"><b> Location: <img src="$web_url/loc.gif">&nbsp;&nbsp;</b></font> <b>Root</b> ($dirs_t Dirs - $links_t Links)];
	$prev_fp = qq[ | <a href="$admin_url/admin26.cgi" onClick="popup('$admin_url/admin26.cgi',screen.width-200,screen.height-200);return false;">Front Page Setups</a>];
	}

## <a href="$script_url/fp.cgi" target="_blank">Preview Front Page</a> | 

$sth->finish;
$dbh->disconnect;


@riditems = split (/-/, $rid); obbuild::get_setupa_line($config_cgi);

$lcount = 1;
foreach $item (@adir)
	{
	
	$nc = $lcount - 1;
	
	if ($nc == 0)
		{
		$rrd = $riditems[$nc];
		}
		else
		{
		$rrd = $rrd . "-" . $riditems[$nc];
		}
	
	$item =~ s/\\'/'/g; #####
	
	if ($lcount == 1)
		{
		$ctst_rl = $ctst_rl . acs::encode_dir($item);
		}
		else
		{
		$ctst_rl = $ctst_rl . "-" . acs::encode_dir($item);
		}
	
	
	if ($nria == $lcount)
		{
		#$item = acs::decode_dir($item);
		$lcstring = $lcstring . " > <b>$item</b> ";
		}
		else
		{
		#$item = acs::decode_dir($item);
		@idit = split (/-/, $rrd);
		$nr_idit = @idit; $nr_idit = $nr_idit - 1;
		$cur_cid = $idit[$nr_idit];
		
		$lcstring = $lcstring . " > <a href=\"$admin_url/admin2.cgi?lv=$lcount&ct=$ctst_rl&rid=$rrd&cid=$cur_cid\">$item</a> ";
		}
	
	$lcount++;
	$cdr = $item;
	}


if ($ct ne "")
{
$plv = $lv - 1;
$lstn = &get_last_dirname($ct);
$prv = " | <a href=\"$script_url/dirs.cgi?lv=$plv&ct=$ct\" target=\"_blank\">Preview <b>$lstn</b></a>";
}

#$lcstring = $lcstring . "<br><b>$rows</b> Sub Directories &amp; <b>$total_links</b> Links in Current Dir $prev_fp";
#$lcstring = $lcstring . "$prv</font>";

$catstats = $catstats . "<b>$rows</b> Sub Directories &amp; <b>$total_links</b> Links in Current Dir $prev_fp";
$catstats = $catstats . "$prv";


if ($lcount == 1){$rloc = "Root ";} else {$rloc = $cdr; }


#### TOP DIRTABLE

if ($dirtable_middle ne "")
	{

$dirtable_top = <<ENDOFTD;

<table width="100%" cellpadding="4" cellspacing="1" bgcolor="#FFFFFF" style="border: 1px solid rgb(219,219,219)">
  <tr>
    <td width="46%" height="30" background="$web_url/bar6.gif"><p><img src="$web_url/dir.gif"><strong> $rloc </strong></p></td>
    <td width="18%" background="$web_url/bar6.gif"><p align="center"><strong>Edit | Move | Delete</strong></td>
    <td width="9%" background="$web_url/bar6.gif"><p align="center"><strong>Generate</strong></td>
    <td width="9%" background="$web_url/bar6.gif"><p align="center"><strong>Adverts</strong></td>
    <td width="9%" background="$web_url/bar6.gif"><p align="center"><strong>Template</strong></td>
    <td width="9%" background="$web_url/bar6.gif"><p align="center"><font color="#000000"><strong>Preview</strong></font></td>
  </tr>

ENDOFTD

$dirtable_bot = qq[</table>];
	}

##$rdata
#<BR>
#$lcstring<br><BR>


$toplinks =~ s/!!expand_retract!!/$expand_extract/gi;
$toplinks =~ s/!!cust_template!!/$cust_template/gi;




$dirtable = <<ENDTD;

<table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#E1E1E1">
  <tr>
    <td width="1%" bgcolor="#FFFFFF" align="center"><p><img src="$web_url/ic_dirm.gif"></td>
    <td width="99%" valign="top" bgcolor="#FFFFFF">
    
    <table width="100%" border="0" cellpadding="6">
      <tr>
        <td background="$web_url/bar6.gif"><strong class="normaltext">Directory Manager</strong></td>
      </tr>
      <tr>
        <td class="normaltext">$catstats</td>
      </tr>
    </table></td>
  </tr>
  <tr>
    <td height="30" colspan="2" bgcolor="#FFFFFF"><p>&nbsp;&nbsp;$lcstring</p></td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>

$dirtable_top
$dirtable_middle
$dirtable_bot
$toplinks
$all_lnks
$retract_box

ENDTD



$template =~ s/!!data!!/$dirtable/g; 
print "$template";
 
}






sub get_crosslinks
{
$cross_linksqlw = substr($cross_linksqlw, 0, length($cross_linksqlw) - 2);

$csql = "SELECT * FROM dirs WHERE $cross_linksqlw";

$sth = $dbh->prepare($csql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $csql";} 

while ( @row = $sth->fetchrow() )
	{
	$cats3	= ""; $rccat = "";
	for ($ms3 = 2; $ms3 < 18; $ms3++) 
		{
		if ($row[$ms3] ne "")
			{
			$rccat = $rccat . $row[$ms3] . "/";
			$cats3 = $cats3 . acs::encode_dir($row[$ms3]) . "-";
			}
		} 
	$cats3 = substr($cats3, 0, length($cats3) -1);
	
	$lvc = $row[1];
	$cidc = $row[0];
	
	$cclink = "-$row[0]-CRSLINK";
	$ccrlink = "$admin_url/admin34.cgi?cid=$cidc&lv=$lvc&ct=$cats3";
	$dirtable_middle =~ s/$cclink/$ccrlink/g;

	$prlink = "-$row[0]-PRVLINK";
	$prrlink = "$script_url/dirs.cgi?cid=$cidc&lv=$lvc&ct=$cats3";
	$dirtable_middle =~ s/$prlink/$prrlink/g;

	$ccstbar = "-$row[0]-ONMOVER";
	$dirtable_middle =~ s/$ccstbar/$rccat/g;
	
	if ($row[20] eq "")  { $row[20] = "0"; }
	$ccnumbers = "-$row[0]-CRSLCNTS";
	$dirtable_middle =~ s/$ccnumbers/$row[20]/g;
	}

}









sub get_links
{

$nowtime = time();

### GET FIELDS/KEYS

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;

if ($q->param('rev') eq "true") { $only_list_reviews = "AND rev_no > 0"; }

if ($gsettings->{dir_sort_links} eq "Popularity")
	 {
	 $pop1 = ", (IFNULL(A.rating,0) + IFNULL(A.votes,0) + IFNULL(A.hits,0)) AS popul ";
	 $pop2 = ", popul DESC, title ASC ";
	 }
elsif ($gsettings->{dir_sort_links} eq "Alphabetical")
	 {
	 $pop2 = ", title ASC";
	 }
elsif ($gsettings->{dir_sort_links} eq "Hits")
	 {
	 $pop2 = ", hitsort DESC, title ASC";
	 }
elsif ($gsettings->{dir_sort_links} eq "Votes")
	 {
	 $pop2 = ", votesort DESC, title ASC";
	 }
elsif ($gsettings->{dir_sort_links} eq "Ratings")
	 {
	 $pop2 = ", ratingsort DESC, title ASC";
	 }
	 elsif ($gsettings->{dir_sort_links} eq "Newest")
	 {
	 $pop2 = ", urldate DESC, title ASC";
	 }
	

	$links_sql = "SELECT A.*, 
				IFNULL(premium, 0) AS premsort,
				IFNULL(rating, 0) AS ratingsort,
				IFNULL(votes, 0) AS votesort,
				IFNULL(hits, 0) AS hitsort
				$pop1
				
	FROM links AS A
	WHERE cid = '$cid' AND ((newsubm = '') OR (newsubm IS NULL)) 
	ORDER BY premsort DESC $pop2";


### WHERE cid = '$cid' AND ((newsubm = '') OR (newsubm IS NULL)) 
### SELECT * FROM links WHERE cid = '$cid' AND ((newsubm = '') OR (newsubm IS NULL)) ORDER BY premium DESC, title

$sth = $dbh->prepare($links_sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $links_sql";}

$total_links = $sth->rows();

$nr_searchres = $gsettings->{cp_link_listings};

#### CREATE START  OF SELECT FORM

$all_lnks = <<END_OFLTOP;
<form name="select_all" method="POST" action="$admin_url/admin5.cgi">
<input type="hidden" name="fct" value="link_functions">
<input type="hidden" name="ct" value="$ct">
<input type="hidden" name="rid" value="$rid">
<input type="hidden" name="cid" value="$cid">
<blockquote><p class="normaltext">
%%linkoptions%%
END_OFLTOP


#### PAGES

$icnt = $total_links;
$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}
	
$st = $q->param('st');
$nd = $q->param('nd');

$main_nd = $nd;
$main_st = $st;

if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}
	
$ippc = 1;
$nr_disp = 0;

############

$nowtime = time();

while ( @row = $sth->fetchrow() )
	{
	$chknm = "C" . $nr_disp;
	

if (($ippc > $st) and ($ippc <= $nd))
   {		
	$chkstring = $chkstring . "'$chknm',";


if ($gsettings->{htmldisplay} eq "htmlon")
	{
	$row[3] =~ s/</&lt;/g; $row[3] =~ s/>/&gt;/g; 
	$row[4] =~ s/</&lt;/g; $row[4] =~ s/>/&gt;/g; 
	}


	if ($row[3] ne ""){$row[3] = $row[3] . "<br>";}
	if ($row[4] ne ""){$row[4] = "Keywords: <b>$row[4]</b><br>";}	
	if ($row[5] ne ""){$row[5] = "$row[5]";}
	
	if ($row[10] eq ""){$row[10] = "0";}
	if ($row[11] eq "") {$row[11] = "0";}
	if ($row[12] eq "") {$row[12] = "0";}

	
	if (($row[21] == 0) and ($row[13] > 0))
	{ $row[21] = 99999999999999; }
	

	####### PREMIUM LISTINGS
	if ($row[13] eq "") {$row[13] = "0";}
	$is_prem_listing = "";
	$pexp_date = "";
	if (($row[13] > 0) and ($row[21] > $nowtime))
		{
		$is_prem_listing = "<img src=\"$web_url/premi2.gif\">";
		$pexp_date = "";
		if (($row[21] > 0) and ($row[21] != 99999999999999))
			{
			$row[21] = acs::decode_date($row[21]);
			$pexp_date = " - <strong><font color=\"#FF0000\">Expiry Date: $row[21]</font></strong>";
			}
			else
			{
			$pexp_date = " - <strong><font color=\"#FF0000\">Never Expires</font></strong>";			
			}
		}
	############
	
	
	if ($row[8] ne ""){$row[8] = "<BR>Name: <b>$row[8]</b><br>";}
	if ($row[9] ne ""){$row[9] = "Email: <b>$row[9]</b>";}
	
	$row[10] = "<b>$row[10]</b>";
	$row[11] = "<b>$row[11]</b>";
	$row[12] = "<b>$row[12]</b>";
	$row[13] = "<b>$row[13]</b>";
	
	$date = acs::decode_date($row[17]);

	
	#### KEYS
	if ($knr > 0)
		{
		$key_disp_data = "";
		$rkcnt = 27;
		foreach $k_item (@akeys)
		{
		($keyname, $visible, $size, $searched, $description, $notext, $imgf, $fieldtype) = split (/\t/, $k_item);

			if ($visible eq "Yes")
				{

				if ($fieldtype eq "Upload")
					{
						if ($row[$rkcnt] ne "") 
							{
							$ifname = "$web_url/imagefiles/$row[0]/$keyname" . "." . $row[$rkcnt];
							$key_disp_data = $key_disp_data . qq[<font color="#804040"><b>$description:</b> <a href="$ifname" target="_blank">$ifname</a></font><BR>];
							}
							else
							{
							$key_disp_data = $key_disp_data . qq[<font color="#804040"><b>$description:</b> N/A</font><BR>];
							}
					}
				elsif ($imgf eq "Yes")
					{
						if ($row[$rkcnt] ne "") {$key_disp_data = $key_disp_data . "<img src=\"$row[$rkcnt]\"><br>";}
					}
					else
					{
						if ($row[$rkcnt] eq "") { $row[$rkcnt] = $notext; }
							
						### IF HTML ON
						if ($gsettings->{htmldisplay} eq "htmlon"){ $row[$rkcnt] =~ s/</&lt;/g; $row[$rkcnt] =~ s/>/&gt;/g; }
								
						$key_disp_data = $key_disp_data . qq[<font color="#8080C0"><b>$description:</b> $row[$rkcnt]</font><br>];
					}

				}
		$rkcnt++;
		}
	}
	

	###########
	
	$rvws = "";
	if ($row[23] > 0)
		{
		$rvws = " | <a href=\"$admin_url/admin15.cgi?lnkid=$row[0]\" onClick=\"popup('$admin_url/admin15.cgi?lnkid=$row[0]',750,600);return false;\">Reviews</a>($row[23]) ";
		}

	if ($row[22] eq "") { $row[22] = "N/A"; }

	### CHECK IF THIS IS A NEW LINK
	$newgif = "";
	$new1secs = $gsettings->{days1} * 86400;
	$new1time = $nowtime - $new1secs;
	if ($row[17] > $new1time)
		{
		$newgif = "<img src=\"$web_url/new1.gif\">";
		}

	### CHECK IF NEW2
	if ($newgif eq "")
	{
	$new1secs = $gsettings->{days2} * 86400;
	$new1time = $nowtime - $new1secs;
	if ($row[17] > $new1time)
		{
		$newgif = "<img src=\"$web_url/new2.gif\">";
		}
	}
		
	### CHECK IF NEW3
	if ($newgif eq "")
	{
	$new1secs = $gsettings->{days3} * 86400;
	$new1time = $nowtime - $new1secs;
	if ($row[17] > $new1time)
		{
		$newgif = "<img src=\"$web_url/new3.gif\">";
		}
	}




if ($gsettings->{htmldisplay} eq "htmlon") ### IF HTML ON
	{
	$row[2] =~ s/</&lt;/g; $row[2] =~ s/>/&gt;/g; 
	}

if (($row[5] eq "http://") or ($row[5] eq ""))
	{
	$cplinkds = "<b>$row[2]</b>";
	$display_url = "No URL";
	}
	else
	{
	$cplinkds = "<a href=\"$row[5]\" target=\"_blank\"><b>$row[2]</b></a>";
	$display_url = $row[5];
	}

### NEW SUBMISSIONS
#$newsubm = ""; $input_box = "";
#if ($row[15] ne "")
#	{
#	$newsubm = "<font color=\"#FF8000\"><b><i>New Submission - Waiting for Approval</i></b></font>";
#	}

$recip = "";
if ($row[25] ne "") { $recip = qq[<font color="#0080FF"> Reciprocal Link: <a href="$row[25]" target="_blank">$row[25]</a></font><BR>]; }





	$user_account_jump = "";
	if ($row[16] > 0) ### IF USER ACCOUNT EXISTS FOR LINK
		{
		$user_account_jump = qq[ | <a href="$admin_url/admin55.cgi?fct=editacc&userid=$row[16]" onClick="popup('$admin_url/admin55.cgi?fct=editacc&userid=$row[16]',750,600);return false;">User Account</a>];
		}


$imagedis = "";
if ($row[6] ne "")
	{

		if ((lc($row[6]) eq "tif") or (lc($row[6]) eq "png") or (lc($row[6]) eq "jpg") or (lc($row[6]) eq "jpeg") or (lc($row[6]) eq "gif") or (lc($row[6]) eq "bmp"))
		{
			if (($gsettings->{image_width} > 0) and ($gsettings->{image_height} > 0))
				{
				$width = $gsettings->{image_width};
				$height = $gsettings->{image_height};
				$imgwh = qq[width="$width" height="$height"];
				}
		$imagedis = qq[<BR><img src="$web_url/imagefiles/$row[0].$row[6]" $imgwh><BR><BR>];
		}
		else
		{
		$imagedis = qq[<b>File:</b> <a href="$web_url/imagefiles/$row[0].$row[6]" target="_blank">$row[0].$row[6]</a><BR><BR>];
		
		}
	}



$cc_val = $row[0] . "-" . $row[1];


if ($gsettings->{addurl_reg_system} ne "Yes")
	{
	$modify_password = "Password: <b>$row[22]</b><br>";
	}

$all_lnks = $all_lnks . qq[

<table border="0" cellpadding="4" cellspacing="0" width="100%">
  <tr>
    <td width="1%" valign="top"><input type="checkbox" name="$chknm" value="$row[0]"><br>$is_prem_listing</td>
    <td width="99%" class="normaltext"><b>$ippc.</b>  $cplinkds $newgif $newsubm<br>
    $row[3] $row[4] <b>$display_url</b><br>
    $date<br>
    $modify_password
    Rating: $row[10] | Votes: $row[11] | Hits: $row[12]<br>
    Premium Pos: $row[13] $pexp_date $row[8] $row[9] $recip <BR>ID: <b>$row[0]</b> <br>
    $key_disp_data 
    
    <b>[ <a href="$admin_url/admin56.cgi?itemnrs=1&C0=$cc_val&dropdown=Edit" onClick="popup('$admin_url/admin56.cgi?itemnrs=1&C0=$cc_val&dropdown=Edit',screen.width-200,screen.height-200);return false;">Edit</a> 
    | <a href="$admin_url/admin56.cgi?itemnrs=1&C0=$cc_val&dropdown=Move" onClick="popup('$admin_url/admin56.cgi?itemnrs=1&C0=$cc_val&dropdown=Move',screen.width-200,screen.height-200);return false;">Move</a> 
    | <a href="$admin_url/admin56.cgi?itemnrs=1&C0=$cc_val&dropdown=Copy" onClick="popup('$admin_url/admin56.cgi?itemnrs=1&C0=$cc_val&dropdown=Copy',screen.width-200,screen.height-200);return false;">Copy</a> 
    | <a href="$admin_url/admin56.cgi?itemnrs=1&C0=$cc_val&dropdown=Delete" onClick="popup('$admin_url/admin56.cgi?itemnrs=1&C0=$cc_val&dropdown=Delete',screen.width-200,screen.height-200);return false;">Delete</a> 
    $rvws $user_account_jump ]</b>
    $imagedis</td>
  </tr>
</table>
<BR>
];




#<input type="checkbox" name="$chknm" value="$row[0]"><b>$ippc.</b> $is_prem_listing $cplinkds $newgif $newsubm<br>
#$row[3]
#$row[4]
#<b>$display_url</b><br>
#$date<br>
#Password: <b>$row[22]</b><br>
#Rating: $row[10]
#Votes: $row[11]
#Hits: $row[12]
#Premium: $row[13] $pexp_date
#$row[8]
#$row[9] $recip
#$rvws 
#ID: <b>$row[0]</b>
#<br>
#$key_disp_data 
#$user_account_jump $imagedis
#<br><br>


  $nr_disp++;

	$crit = "<img src=\""; $all_lnks =~ s/\[img\]/$crit/gi;
	$crit = "\">"; $all_lnks =~ s/\[\/img\]/$crit/gi;

	$crit = "<a href=\"$row[5]\" target=\"_blank\"><img src=\""; $all_lnks =~ s/\[imglnk\]/$crit/gi;
	$crit = "\" border=\"0\"></a>"; $all_lnks =~ s/\[\/imglnk\]/$crit/gi;

  }
$ippc++;
}
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }



if ($total_links > 0)
	{
	
	######## PAGES
	$nwrid = $rid;
	chop($nwrid);
	

	for ($ms = 0; $ms < $pages; $ms++) 
		{
		$pg = $ms + 1;
		if ($nd == ($pg * $nr_searchres)){ $cnposition = $pg; }
		}
	if ($cnposition < $pages_next) { $pages_next = $pages_next + $pages_next - ($cnposition - 1); }

	$hiddenstr = "";
	$pgstring = "";
	
	if ($main_nd eq "") {$main_nd = $nr_searchres;}
	
	for ($ms = 0; $ms < $pages; $ms++)
		{
		$pg = $ms + 1;
		
			if ($main_nd == ($pg * $nr_searchres))
				{
				$pgstring = $pgstring . " [$pg] ";
				$currentpage = $pg;
				}
			  	elsif (($pg >= ($cnposition - $pages_prev)) and ($pg <= ($cnposition + $pages_next)))
				{
				$st = ($pg * $nr_searchres) - $nr_searchres;
				$nd = ($pg * $nr_searchres);
				$pgstring = $pgstring . "<a href=\"$admin_url/admin2.cgi?st=$st&nd=$nd&lv=$rlv&ct=$ct&cid=$cid&rid=$nwrid\">$pg</a> ";
			   }
      } 

			####  PAGES NAVIGATION
			if (($cnposition - $pages_prev) > 1)
				{
				$prev_ppos = $cnposition - $pages_prev;
				$staticpos = $prev_ppos - 1;
				$prev_ppos = $prev_ppos - 2;
				$pvst = $prev_ppos * $nr_searchres;
				$pvnd = ($prev_ppos * $nr_searchres) + $nr_searchres;
				
				$pgstring = "<a href=\"$admin_url/admin2.cgi?st=$pvst&nd=$pvnd&lv=$rlv&ct=$ct&cid=$cid&rid=$nwrid\"><<</a> " . $pgstring;
				}

			####  PAGES NAVIGATION
			if (($cnposition + $pages_next) < $pages)
				{
				$next_ppos = $cnposition + $pages_next;
				$staticpos = $next_ppos + 1;
				$pvst = $next_ppos * $nr_searchres;
				$pvnd = ($next_ppos * $nr_searchres) + $nr_searchres;
				$pgstring = $pgstring . "<a href=\"$admin_url/admin2.cgi?st=$pvst&nd=$pvnd&lv=$rlv&ct=$ct&cid=$cid&rid=$nwrid\">>></a> ";
				}


	$pgstring = "<b>Pages:</b> " . $pgstring;



### PREV NEXT PAGES

$st = $q->param('st');
$nd = $q->param('nd');
if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}


$spls = $modp;
if ($spls == 0){$spls++;}

if ($nd <= ($icnt - $spls))
{
	$st1 = $st + $nr_searchres;
	$nd1 = $nd + $nr_searchres;
	$nextt = "<a href=\"$admin_url/admin2.cgi?st=$st1&nd=$nd1&lv=$rlv&ct=$ct&cid=$cid&rid=$nwrid\">Next Page >></a> ";
}

 if ($st > 0)
	 	{
		$st1 = $st - $nr_searchres;
		$nd1 = $nd - $nr_searchres;
		$prev = "<a href=\"$admin_url/admin2.cgi?st=$st1&nd=$nd1&lv=$rlv&ct=$ct&cid=$cid&rid=$nwrid\"><< Previous Page</a> ";
		}

if (($prev ne "") and ($nextt ne ""))
	{
	$spcer = " | ";
	}
	else
	{
	$spcer = " ";
	}
	  
	$prevnext = $prev . "$spcer" . $nextt;

	#if (length($prevnext) > 5){$myspacer = " | ";}
	#$pgstring = $pgstring . $myspacer . $prevnext;



### SET UP CHECK UNCHECK ALL
	
chop ($chkstring);
	
	
	##window.location.href='$admin_url/admin76.cgi?' + windowURL;
	## myWin = open('$admin_url/admin76.cgi?' + windowURL);
	#document.select_all.listperpage.selectedIndex
$jscr = <<END_OF_JSC;
<script LANGUAGE="JavaScript">
<!-- Hide

function submit_linksperpage(selval)
	{
	 var prep;

 	  if (selval = 1)
 	   	{
 	   	prep = select_all.listperpage1.value;
 	   	}
 	   	else
 	   	{
 	   	prep = select_all.listperpage.value;
 	   	}
		 
		 var windowURL;
	    windowURL =  'nr_links=' + prep + '&';
	    windowURL = windowURL + 'ct=$ct&';
	    windowURL = windowURL + 'lv=$lv&';
	    windowURL = windowURL + 'rid=$rid&';
	    windowURL = windowURL + 'cid=$cid&';
    	 windowURL = windowURL + 'fct=link_functions';
    	 window.location.href = '$admin_url/admin76.cgi?' + windowURL;
	}


function checkall(formname,thestate)
	{
	BoxNames=new Array($chkstring)
	for (c=0;c < BoxNames.length; c++)
		{
		boxname = eval("document." + formname + "." + BoxNames[c])
		boxname.checked = thestate
		}
	}

function submitForm(theForm, selv) 
  {
  BoxNames=new Array($chkstring)
  windowName = "PowerSeek";
  windowURL = theForm.action + '?';
  var c = 0;
	for (c=0;c < BoxNames.length; c++)
		{
		chvl = eval("theForm." + BoxNames[c] + ".checked");
		if (chvl)
			{
			boxnm = eval("theForm." + BoxNames[c] + ".value");
			windowURL = windowURL + BoxNames[c] + '=' + boxnm + '&';
			}
		}
    windowURL = windowURL + 'nr_links=$nr_disp&';
    windowURL = windowURL + 'ct=$ct&';
    windowURL = windowURL + 'lv=$lv&';
    windowURL = windowURL + 'rid=$rid&';
    windowURL = windowURL + 'cid=$cid&';
    windowURL = windowURL + 'fct=link_functions&';
    
    if (theForm.opaction1.value == "Delete")
    	{
    	 var wval = 750;
	    var hval = 150;
    	}
    	else
    	{
	    var wval = screen.width-200;
	    var hval = screen.height-200;
    	}
    
    if (selv == 1)
    	{
    	windowURL = windowURL + 'opaction1=' + theForm.opaction1.value;
    	}
    	else
    	{
    	windowURL = windowURL + 'opaction=' + theForm.opaction.value;
    	}
    
    
    var myspecs = 'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=' + wval + ',height=' + hval + ',top=50,left=50';
    var popupwin = null;
    
    var random = parseInt(Math.random()*10000)
    
    myWindow = window.open(windowURL, 'popupwin' + random, myspecs);
    myWindow.focus();
  } 

// -->
</script>

END_OF_JSC

	
	$template =~ s/<!-- Hide !!JSCRIPT!! \/\/ End Hide -->/$jscr/gi;


#### LINK BOTTOM	

$rv_lv = $lv - 1;
$rv_rid = substr($rid, 0, length($rid) -1);

#if ($q->param('rev') eq "true") 
#	{
#	$list_oreviews = "<a href=\"$admin_url/admin2.cgi?lv=$rv_lv&ct=$ct&cid=$cid&rid=$rv_rid\">List All</a>";
#	}
#	else
#	{
#	$list_oreviews = "<a href=\"$admin_url/admin2.cgi?lv=$rv_lv&ct=$ct&cid=$cid&rid=$rv_rid&rev=true\">Only list links with reviews</a>";
#	}


$link_option_table = <<END_OF_LOPTIONS;


<table width="98%" border="0" cellpadding="0" align="center">
  <tr>
    <td width="70%">
    <p class="normaltext">
    <a href="javascript:checkall('select_all',true)">Check All</a> | 
	 <a href="javascript:checkall('select_all',false)">UnCheck All</a> | $pgstring
	 </span>
    </td>
    <td width="30%" align="right">
    <p class="normaltext">
    <b>$prevnext</b></td>
  </tr>
</table>
<BR>

<table border="0" cellpadding="1" cellspacing="0" width="98%" align="center">
  <tr>
    <td width="1%"><select name="opaction1" size="1"
    style="font-family: MS Sans Serif; font-size: 8pt">
      <option value="Edit">Edit Checked Items</option>
      <option value="Move">Move Checked Items</option>
      <option value="Copy">Copy Checked Items</option>
      <option value="Delete">Delete Checked Items</option>
    </select></td>
    <td width="1%"><input type="submit" value="   Go   " name="topb"
    style="font-family: MS Sans Serif; font-size: 8"
    onClick="submitForm(document.select_all,1); return false;"></td>
    <td width="1%"></td>
    <td width="151"><select name="listperpage1" size="1" style="font-family: MS Sans Serif; font-size: 8pt">
      <option value="10">List 10 Links Per Page</option>
      <option value="20">List 20 Links Per Page</option>
      <option value="30">List 30 Links Per Page</option>
      <option value="40">List 40 Links Per Page</option>
      <option value="50">List 50 Links Per Page</option>
      <option value="75">List 75 Links Per Page</option>
      <option value="100">List 100 Links Per Page</option>
      <option value="200">List 200 Links Per Page</option>
      <option value="500">List 500 Links Per Page</option>
      <option value="1000">List 1000 Links Per Page</option>
    </select></td>
    <td width="96%"><input type="submit" value="   Go   " name="ppga"
    style="font-family: MS Sans Serif; font-size: 8" 
    onClick="submit_linksperpage(document.select_all,1); return false;"></td>
  </tr>
</table>



END_OF_LOPTIONS

#<input type="submit" value="   Go   " name="topb" style="font-family: MS Sans Serif; font-size: 8">
#<input src="$web_url/go.gif" name="topb" type="image" onClick="submitForm(document.select_all); return false;" value="submit">

$hlinev = qq[<hr size="1" color="#DBDBDB" noshade width="98%">];

$all_lnks =~ s/%%linkoptions%%/$link_option_table $hlinev<br>/g;

$link_option_table =~ s/opaction1/opaction/g;
$link_option_table =~ s/listperpage1/listperpage/g;

$link_option_table =~ s/document.select_all,1/document.select_all,0/g;

$all_lnks = $all_lnks . <<END_OFB;

$hlinev
$link_option_table
<input type="hidden" name="nr_links" value="$nr_disp">
END_OFB
	
	#$list_oreviews
	#<input type="submit" value="Go" name="B1" onClick="submitForm(document.select_all); return false;">
	#<input src="$web_url/go.gif" name="I1" type="image" onClick="submitForm(document.select_all); return false;" value="submit"></td>
	}
	else
	{
	$all_lnks =~ s/%%linkoptions%%//g;
	}





$all_lnks = $all_lnks . "</span></blockquote>";



}






##################################################################################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}

			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

